////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                                                                            //
//                      Coded by Max Sibenschläfer                            //
//                                                                            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include <String.h>
#include <ESP8266WiFi.h>

// Replace with your network credentials
const char* ssid     = "___________";
const char* password = "___________";

// Set web server port number to 80
WiFiServer server(80);

// Variable to store the HTTP request
String header;

// Auxiliar variables to store the current output state
String output5State = "off";
String output4State = "off";

// Assign output variables to GPIO pins
const int links = 5;
const int links1 = 4;
const int rechts = 13;
const int rechts1 = 12;

// Current time
unsigned long currentTime = millis();
// Previous time
unsigned long previousTime = 0; 
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 2000;

void setup() {
  Serial.begin(115200);
  
  pinMode(links , OUTPUT);
  pinMode(links1 , OUTPUT);
  pinMode(rechts , OUTPUT);
  pinMode(rechts1 , OUTPUT);

  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
}

void loop(){
  WiFiClient client = server.available();   // Listen for incoming clients

  if (client) {                             // If a new client connects,
    Serial.println("New Client.");          // print a message out in the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    currentTime = millis();
    previousTime = currentTime;
    while (client.connected() && currentTime - previousTime <= timeoutTime) { // loop while the client's connected
      currentTime = millis();         
      if (client.available()) {             // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
        Serial.write(c);                    // print it out the serial monitor
        header += c;
        if (c == '\n') {                    // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();
            
            // turns the GPIOs on and off
            if (header.indexOf("GET /Gerade") >= 0) {
              Serial.println("Gerade");
              //for (int i = 0;i<10;i++) {
                digitalWrite(links , HIGH);
                digitalWrite(links1 , LOW);
                digitalWrite(rechts , LOW);
                digitalWrite(rechts1 , HIGH);
        //      output5State = "on";
          //    digitalWrite(output5, HIGH);
            } else if (header.indexOf("GET /Zurueck") >= 0) {
              Serial.println("Zurueck");
                digitalWrite(links , LOW);
                digitalWrite(links1 , HIGH);
                digitalWrite(rechts , HIGH);
                digitalWrite(rechts1 , LOW);
              
                
           //   output5State = "off";
           //   digitalWrite(output5, LOW);
            } else if (header.indexOf("GET /Links") >= 0) {
              Serial.println("Links");
                digitalWrite(links , LOW);
                digitalWrite(links1 , HIGH);
                digitalWrite(rechts , LOW);
                digitalWrite(rechts1 , HIGH);               
            //  output4State = "on";
            //  digitalWrite(output4, HIGH);
            } else if (header.indexOf("GET /Rechts") >= 0) {
              Serial.println("Rechts");
                digitalWrite(links , HIGH);
                digitalWrite(links1 , LOW);
                digitalWrite(rechts , HIGH);
                digitalWrite(rechts1 , LOW);
              
           //   output4State = "off";
           //   digitalWrite(output4, LOW);
           } else if (header.indexOf("GET /Stop") >= 0) {
              Serial.println("Stop");
              digitalWrite(links , LOW);
              digitalWrite(links1 , LOW);
              digitalWrite(rechts , LOW);
              digitalWrite(rechts1 , LOW);
           //   output4State = "off";
           //   digitalWrite(output4, LOW);
            }
            else if (header.indexOf("GET /") >= 0) {
              Serial.println("Stop");
              digitalWrite(links , LOW);
              digitalWrite(links1 , LOW);
              digitalWrite(rechts , LOW);
              digitalWrite(rechts1 , LOW);
           //   output4State = "off";
           //   digitalWrite(output4, LOW);
            }
            
            // Display the HTML web page
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            // CSS to style the on/off buttons 
            // Feel free to change the background-color and font-size attributes to fit your preferences
            client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button { background-color: #195B6A; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
            client.println(".button2 {background-color: #77878A;}</style></head>");
            
            
            client.println("<body><h1>ESP8266 Web Server Mark IV Panzersteuerung</h1>");
            
            // Display current state, and ON/OFF buttons for GPIO 5  
            client.println("<p>Vor</p>");
            // If the output5State is off, it displays the ON button       
            if (output5State=="off") {
              client.println("<p><a href=\"/Gerade\"><button class=\"button\">Vor</button></a></p>");
            } 
    
               
            // Display current state, and ON/OFF buttons for GPIO 4  
            client.println("<p>Zurück</p>");
            // If the output4State is off, it displays the ON button       
           if (output4State=="off") {
              client.println("<p><a href=\"/Zurueck\"><button class=\"button\">Zurück</button></a></p>");
            } 
         
            // Display current state, and ON/OFF buttons for GPIO 4  
            client.println("<p>Links</p>");
            // If the output4State is off, it displays the ON button       
           if (output4State=="off") {
              client.println("<p><a href=\"/Links\"><button class=\"button\">Links</button></a></p>");
           }
       

            // Display current state, and ON/OFF buttons for GPIO 4  
            client.println("<p>Rechts</p>");
            // If the output4State is off, it displays the ON button       
            if (output4State=="off") {
              client.println("<p><a href=\"/Rechts\"><button class=\"button\">Rechts</button></a></p>");
           } 

           // Display current state, and ON/OFF buttons for GPIO 4  
            client.println("<p>Stop</p>");
            // If the output4State is off, it displays the ON button       
            if (output4State=="off") {
              client.println("<p><a href=\"/Stop\"><button class=\"button\">Stop</button></a></p>");
           } 
   
            client.println("</body></html>");
            
            // The HTTP response ends with another blank line
            client.println();
            // Break out of the while loop
            break;
          } else { // if you got a newline, then clear currentLine
            currentLine = "";
          }
        } else if (c != '\r') {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }
      }
    }
    // Clear the header variable
    header = "";
    // Close the connection
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }
}
